<?php
/*
 * $RCSfile: module.inc,v $
 *
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2005 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
/**
 * @package Puzzle
 * @version $Revision: 0.9 $ $Date: 2005/11/12 20:28:11 $
 * @author J. Mike Rollins <rollins@CamoTruck.Net>
 */

/**
 * CamoTruck.Net Puzzle Module
 *
 * This module provides support for adding puzzles to items
 *
 * @package Puzzle
 */
class puzzleModule extends GalleryModule 
  {
    function puzzleModule() 
      {
        global $gallery;

        $this->setId('puzzle');
        $this->setName('Puzzle Module');
        $this->setDescription($gallery->i18n('CamoTruck.Net: Puzzle Module'));
        $this->setVersion('0.9.1');
        $this->setGroup('display', $this->translate('Display'));
        $this->setCallbacks('getItemLinks');
        $this->setRequiredCoreApi(array(6, 8));
        $this->setRequiredModuleApi(array(2, 0));
      }

    /**
     * @see GalleryModule::autoConfigure
     */
    function autoConfigure() 
      {
        /* We don't require any special configuration */
        return array(GalleryStatus::success(), true);
      }

   /**
     * @see GalleryModule::getItemLinks()
     */
    function getItemLinks($items, $wantsDetailedLinks, $permissions) 
      {
        $links = array();

        foreach ($items as $item) 
          {
            $itemId = $item->getId();
            if (isset($wantsDetailedLinks[$itemId])) 
              {
                if (GalleryUtilities::isA($item, 'GalleryPhotoItem')) 
                  {
                    $params['view'] = 'puzzle.MakePuzzle';
                    $params['itemId'] = $itemId;
                    $params['return'] = 1;
                    $links[$item->getId()][] =
                        array('text' => $this->translate('Puzzle'),
                              'params' => $params);
                  }
              }
          }

        return array(GalleryStatus::success(), $links);
      }

}



?>
